#


class SmallHealthPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Small Health Potion"
        self.hp_recovered = 10
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.current_health += self.hp_recovered * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and restores" + str(self.hp_recovered * num) + " HP")

    def pick_up(self, num):
        self.quantity += num


class MediumHealthPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "medium Health Potion"
        self.hp_recovered = 50
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.current_health += self.hp_recovered * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and restores" + str(self.hp_recovered * num) + " HP")

    def pick_up(self, num):
        self.quantity += num


class LargeHealthPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Large Health Potion"
        self.hp_recovered = 200
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.current_health += self.hp_recovered * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and restores" + str(self.hp_recovered * num) + " HP")

    def pick_up(self, num):
        self.quantity += num


class SmallDamagePotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Small Damage Potion"
        self.pc.attack = 2
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.attack += self.attack_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.attack_increase * num) + " AtkDmg")

    def pick_up(self, num):
        self.quantity += num


class MediumDamagePotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Medium Damage Potion"
        self.pc.attack = 4
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.attack += self.attack_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.attack_increase * num) + " AtkDmg")

    def pick_up(self, num):
        self.quantity += num


class LargeDamagePotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Large Damage Potion"
        self.pc.attack = 6
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.attack += self.attack_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.attack.damage * num) + " AtkDmg")

    def pick_up(self, num):
        self.quantity += num


class SmallAbilityPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Small Ability Potion"
        self.ability_increase = 3
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.ability += self.ability_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.ability_increase * num) + " Ability")

    def pick_up(self, num):
        self.quantity += num


class MediumAbilityPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Medium Ability Potion"
        self.ability_increase = 6
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.ability += self.ability_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.ability_increase * num) + " Ability")

    def pick_up(self, num):
        self.quantity += num


class LargeAbilityPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Large Ability Potion"
        self.ability_increase = 10
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.ability += self.ability_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.ability_increase * num) + " Ability")

    def pick_up(self, num):
        self.quantity += num


class SmallDefencePotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Small Defence Potion"
        self.defence_increase = 3
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.defence += self.defence_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.defence_increase * num) + " Defence")

    def pick_up(self, num):
        self.quantity += num


class MediumDefencePotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Medium Defence Potion"
        self.defence_increase = 6
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.defence += self.defence_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.defence_increase * num) + " Defence")

    def pick_up(self, num):
        self.quantity += num


class LargeDefencePotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Large Defence Potion"
        self.defence_increase = 10
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.defence += self.defence_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.defence_increase * num) + " Defence")

    def pick_up(self, num):
        self.quantity += num


class SmallSpeedPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Small Speed Potion"
        self.speed_increase = 3
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.speed += self.speed_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.speed_increase * num) + " Speed")

    def pick_up(self, num):
        self.quantity += num


class MediumSpeedPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Medium Speed Potion"
        self.speed_increase = 6
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.speed += self.speed_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.speed_increase * num) + " Speed")

    def pick_up(self, num):
        self.quantity += num


class LargeSpeedPotion(object):
    def __init__(self, pc):
        self.pc = pc
        self.name = "Large Speed Potion"
        self.speed_increase = 10
        self.quantity = 1

    def use(self, num):
        if self.quantity >= num:
            self.pc.speed += self.speed_increase * num
            self.quantity -= 1 * num
            print(self.pc.player_name + " drinks the potion, and gains" + str(self.speed_increase * num) + " Speed")

    def pick_up(self, num):
        self.quantity += num